<script lang="ts">
  import SvgOrg from "./svg/Org.svg.svelte";
  import DesignSvg from "./svg/Design.svg.svelte";
  import DevSvg from "./svg/Dev.svg.svelte";
  import LabsSvg from "./svg/Labs.svg.svelte";
  import SpaceSvg from "./svg/Space.svg.svelte";
  import OrgText from "./txt/Org.txt.svelte";
  import LabsText from "./txt/Labs.txt.svelte";
  import DesignText from "./txt/Design.txt.svelte";
  import DevText from "./txt/Dev.txt.svelte";
  import SpaceText from "./txt/Space.txt.svelte";
  import { EArea } from "../../enums/EArea";
  import type { ComponentType } from "svelte";
  import Dot from "../Dot.svg.svelte";

  export let area: EArea,
    align = "left",
    classes: string = "";

  let name: string,
    tag: string,
    textComponent: ComponentType,
    svgComponent: ComponentType;

  switch (area) {
    case EArea.ORG:
      name = "КОМПАНИЯ";
      tag = "ORG";
      textComponent = OrgText;
      svgComponent = SvgOrg;
      break;

    case EArea.LABS:
      name = "ИССЛЕДОВАНИЯ";
      tag = "LABS";
      textComponent = LabsText;
      svgComponent = LabsSvg;
      break;

    case EArea.DEV:
      name = "РАЗРАБОТКА";
      tag = "DEV";
      textComponent = DevText;
      svgComponent = DevSvg;
      break;

    case EArea.DESIGN:
      name = "ДИЗАЙН";
      tag = "DESIGN";
      textComponent = DesignText;
      svgComponent = DesignSvg;
      break;

    case EArea.SPACE:
      name = "СООБЩЕСТВО";
      tag = "SPACE";
      textComponent = SpaceText;
      svgComponent = SpaceSvg;
      break;
  }
</script>

<article
  class="{classes} grid 2xl:grid-cols-2 gap-8 justify-items-center"
>
  {#if align === "left"}
    <svelte:component this={svgComponent} classes="order-last 2xl:order-none w-auto max-w-xl max-h-96" />
  {/if}
  <section
    class="flex flex-col justify-center gap-3 sm:gap-4 lg:gap-5 xl:gap-6 2xl:gap-7"
  >
    <header class="space-y-2">
      <h2
        class="text-4xl sm:text-5xl lg:text-6xl xl:text-7xl 2xl:text-8xl flex items-baseline gap-2 leading-[.75]"
      >
        {tag}<Dot classes="xl:w-3 xl:h-3 2xl:w-4 2xl:h-4" {area} />
      </h2>
      <p
        class="text-3xl sm:text-4xl lg:text-5xl xl:text-6xl 2xl:text-7xl text-neutral-700"
      >
        {name}
      </p>
    </header>
    <p
      class="text-sm sm:text-base lg:text-lg xl:text-xl 2xl:text-2xl text-justify"
    >
      <svelte:component this={textComponent} />
    </p>
  </section>
  {#if align === "right"}
    <svelte:component this={svgComponent} classes="w-auto max-w-xl max-h-96" />
  {/if}
</article>
